.nolist
include \masm32\include\masm32rt.inc

TestWin	PROTO :DWORD
DlgHook	PROTO :DWORD, :DWORD, :DWORD, :DWORD
SubHook	PROTO :DWORD, :DWORD, :DWORD, :DWORD
ShowNum	PROTO :DWORD

show	EQU invoke ShowNum, ; use dwtoa to show a number
info	EQU invoke SendMessage, h_Info, WM_SETTEXT, 0,
ColW	EQU invoke SendDlgItemMessage,hLVP, hLVID, LVM_SETCOLUMNWIDTH,
OFN_ENABLESIZING	EQU 0800000h
lBuf	EQU 512	; length of local general purpose buffer
ID_IC	EQU 6000	; info control
ID_B1	EQU 6001	; ID user button 1
ID_B2	EQU 6002
ID_B3	EQU 6003
ID_B4	EQU 6004

; width of listview columns:
ColW0	EQU 300	; Name
ColW1	EQU 60	; Size
ColW2	EQU 0		; Type (who wants that one??)
ColW3	EQU 120	; Date modified
ColM3	EQU 420	; middle of column 3, Date modified: 360+120/2
ColW4	EQU 0		; Date created

; sizing the dialog:
dlgDX	EQU 100	; extra width left and right
dlgDY	EQU 200	; extra width top and bottom
ed_Mg	EQU 005	; margin right
butH	EQU 024	; button height
butY	EQU 030	; button offset

ClearLocals MACRO	; first instruction after LOCALS 
 mov edx, edi	; save edi to a free ACD register
 mov ecx, ebp	; Base pointer into counter
 mov edi, esp	; current stack pointer as destination
 sub ecx, edi		; subtract from counter
 shr ecx, 2		; divide by 4, stack is dword aligned (3 bytes extra)
 xor eax,eax		; we want zeroed locals
 rep stosd		; fill (5 cycles per local variable)
 mov edi, edx	; give edi back to Windows
ENDM

.data
ofn		OPENFILENAME <>
hParent	dd 0	; global handle to parent dialog
NumBuf	db "I found this number: "
dwtoaBuf	db "This is a buffer for dwtoa",0
ed_H		dd 0		; height of all user controls
ed_W		dd 100	; initial offset user controls
ButFnt		dd 0
GlobFlag	db 0
HookFlag	dd 0
lpOldHook	dd 0
lpOldTB	dd 0
h_Info	dd 0	; handle info static
h_B1	dd 0	; handle button 1
h_B2	dd 0	; handle button 2
h_B3	dd 0	; and 3, unused
hLVP	dd 0	; handle ListView parent
hLV	dd 0	; handle ListView
hLVH	dd 0	; handle ListView header
hCombo	dd 0	; Filter combobox
hFileEd	dd 0	; File editbox
hOK		dd 0	; OK button
HideFolders	dd 0	; Flag for Button 1
ShowMSG	dd IDOK	; for debugging with MessageBox
xUserB	dd 0	; positions of
yUserB	dd 0	; user buttons
_INSTANCE	dd 0	; for CreateWindowEx
rcDlg	RECT <>
NotiJJ	NMHDR <>
dlgW	dd 0
dlgH	dd 0
dlgX	dd 0
dlgY	dd 0
mb_flag	dd IDOK

AppName	db "OpenFile",0
FilterString	db "Batch files",0
FS0		db "*."
DefExt		db "bat",0
		db "Sources",0
FS1		db "*.asm",0
		db "Output",0
FS2		db "*.exe;*.dll",0
		db "Zip archives",0
FS3		db "*.zip",0
		db "All files",0
FS4		db "*",0,0
buffer		db "*.bat",0
		db MAX_PATH-12 dup(0)
bufTitle	db 0,0,MAX_PATH dup(0)

.code

start:	invoke TestWin, chr$("What a gorgeous file open dialog")
	invoke ExitProcess,0

TestWin proc DlgTitle:DWORD
	invoke RtlZeroMemory,addr ofn,SIZEOF ofn
	mov ofn.lStructSize,SIZEOF ofn
	mov ofn.lpstrFilter, OFFSET FilterString
	mov ofn.lpstrDefExt, OFFSET DefExt
	mov ofn.lpfnHook, OFFSET DlgHook
	mov ofn.lpstrFile, OFFSET buffer
	mov ofn.lpstrFileTitle, OFFSET bufTitle
	mov ofn.nMaxFile, MAX_PATH
	mov ofn.lpstrInitialDir,chr$("\masm32\examples\exampl01\dll")
	mov ofn.Flags, OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY\
	or OFN_NONETWORKBUTTON or OFN_OVERWRITEPROMPT or OFN_ENABLEHOOK\
	or OFN_PATHMUSTEXIST or OFN_ENABLESIZING
	mov eax, DlgTitle
	mov ofn.lpstrTitle, eax
	mov HookFlag,1
	invoke GetOpenFileName, ADDR ofn
	.if eax==TRUE
	  ; lea eax,ofn.lpstrFile
	  ; invoke MessageBox,0,[eax],ADDR AppName,MB_OK
	 .if 0
	  lea eax,ofn.lpstrFile
	  mov eax,[eax]
	  xor ecx,ecx
	  mov cx,ofn.nFileOffset
	  add eax,ecx
	  invoke MessageBox,0,eax,ADDR AppName,MB_OK

	  invoke ShowNum,ofn.lCustData
	 .endif
	.endif
	ret
TestWin endp

DlgHook	proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL rcDesktop:RECT, rcNew:RECT
LOCAL sLen:DWORD
LOCAL hLVID:DWORD
LOCAL lvi:LV_ITEM
LOCAL lvc:LV_COLUMN
LOCAL lvFlag:DWORD, lvCt:DWORD, lvPos:DWORD
LOCAL LocBuf[lBuf]:BYTE, pBuf:DWORD
  ClearLocals
  lea eax, LocBuf	; general purpose buffer
  mov pBuf,eax	; pointer to buffer
  mov eax,hwnd
  invoke GetParent,hwnd
  mov hParent,eax	; get a handle to the main dialog

  switch uMsg

  case WM_SIZING
	invoke MessageBox,0,chr$("SIZING"),chr$("Message:"),MB_YESNO

  case WM_DESTROY
	invoke DestroyWindow,h_Info
	invoke DestroyWindow,h_B1
	; invoke DestroyWindow,h_B2
	.if eax==0
	invoke MessageBox,0,chr$("DESTROY failed"),str$(eax),MB_YESNO
	.endif

  case WM_INITDIALOG
	invoke GetDesktopWindow
	mov ecx,eax	; avoiding error A2133
	invoke GetClientRect, ecx, addr rcDesktop
	invoke GetClientRect, hParent, addr rcDlg

	mov eax,rcDlg.right
	add eax, ed_W	; extra space for our user controls
	add eax, dlgDX	; extra width
	mov dlgW, eax	; new dialog WIDTH
	sub rcDesktop.right,eax

	mov eax,rcDesktop.right
	shr eax,1	; divide by 2 for centering
	mov rcDlg.left, eax

	mov eax,rcDlg.bottom
	add eax, dlgDY	; extra height
	mov dlgH,eax	; new dialog HEIGHT
	sub rcDesktop.bottom,eax

	mov eax,rcDesktop.bottom
	shr eax,1	; divide by 2 for centering
	mov rcDlg.top, eax

  case WM_COMMAND
	.if ShowMSG==IDOK	; never seen
		invoke MessageBox,0,str$(wParam),chr$("WM_COMMAND"),MB_OKCANCEL
		mov ShowMSG, eax
	.endif

  case WM_NOTIFY
	mov eax,lParam	; Pointer to NOTIFY structure
	mov eax,[eax+8]	; message+8

	SWITCH eax	; here are the goodies
; ***********************
	case -601	; CDN_INITDONE - only once
	  ; invoke MessageBox,0,chr$("Init done"),addr AppName,MB_OKCANCEL
; ***********************
	case -602	; CDN_SELCHANGE
	;  invoke MessageBox,0,chr$("Selection changed"),addr AppName,MB_OKCANCEL
; ***********************
	case -606	; OK button pressed
; ***********************
	case -607	; CDN_FILTERCHANGE

 	  invoke SendMessage, hFileEd,WM_SETTEXT,0,0
	  invoke GetDlgItem, hParent, IDOK
	  mov hOK,eax
	  invoke SetFocus,hOK
	  invoke SendMessage, hOK, WM_KEYDOWN, VK_SPACE, 0
	  invoke SendMessage, hOK, WM_CHAR, VK_SPACE, 0
	  invoke SendMessage, hOK, WM_KEYUP, VK_SPACE, 0 ; see FOLDERCHANGE
; ***********************
	case -608	; CDN_INCLUDEITEM - not really useful
; ***********************
	case -603	; CDN_FOLDERCHANGE
	.IF h_Info
	.if HideFolders
	  invoke RtlZeroMemory,pBuf,lBuf
	  info cfm$("Use the left arrow to see earlier folders")
	.endif
	.ENDIF

	invoke GetDlgItem, hParent, lst2	; has to be repeated because 
	mov hLVP, eax		; Explorer creates it anew...
	.IF hLVP
	.IF HookFlag==1	; see http://www.modula2.org/projects/custsavedialog.php
	    mov HookFlag,0	; do this once

	    invoke SendMessage, eax, WM_COMMAND, 0702Ch, 0 ;ODM_VIEW_DETAIL
	    ; invoke MessageBox,0,chr$("Detailed view selected"),addr AppName,MB_OKCANCEL

	    ; adjust main dialog
	    invoke MoveWindow,hParent,rcDlg.left,rcDlg.top,dlgW,dlgH,1

	    ; adjust width of listview
	    invoke GetClientRect,hLVP,addr rcNew
	    mov eax,rcNew.right
	    sub eax,ed_W	  ; offset user control
	    invoke SetWindowPos,hLVP,NULL,0,0,eax,rcNew.bottom,
	    SWP_NOZORDER or SWP_NOMOVE

		invoke GetModuleHandle,0
		mov _INSTANCE,eax
		invoke GetWindowRect,hLVP,addr rcNew ; get the upper right corner
		mov eax,rcNew.right
		sub eax,rcNew.left
		add eax,12
		mov xUserB,eax
		mov yUserB,33	; 33 about right
		mov eax,rcNew.bottom
		sub eax,122
		mov ed_H,eax
		mov eax, ed_W
		sub eax, ed_Mg	; and a little margin
		mov ed_W,eax

		invoke CreateWindowEx,0,chr$("BUTTON"),chr$("Hide folders"),
		WS_CHILD or WS_CLIPSIBLINGS or WS_TABSTOP,
		xUserB, yUserB, ed_W, butH, hParent,ID_B1,_INSTANCE,0
		mov h_B1,eax	; show with SetWindowPos
		invoke SetWindowLong,h_B1,GWL_WNDPROC,SubHook
		mov lpOldHook, eax
		invoke GetStockObject, ANSI_VAR_FONT
		mov ButFnt, eax
		invoke SendMessage, h_B1, WM_SETFONT, eax,1
		invoke ShowWindow,h_B1,SW_SHOWNORMAL
		mov eax,butY
		sub ed_H,eax
		add yUserB,eax
		; .if 0 ; optional button 2
		; invoke CreateWindowEx,0,chr$("BUTTON"),chr$("&Files"),
		; WS_CHILD or WS_CLIPSIBLINGS or WS_TABSTOP,
		; xUserB, yUserB, ed_W, butH, hParent,ID_B2,_INSTANCE,0
		; mov h_B2,eax	; show with SetWindowPos
		; invoke SetWindowLong,h_B2,GWL_WNDPROC,SubHook
		; mov lpOldHook, eax
		; invoke ShowWindow,h_B2,SW_SHOWNORMAL
		; mov eax,butY
		; sub ed_H,eax
		; add yUserB,eax
		; .endif
		; .if 0 ; optional button 3
		; invoke CreateWindowEx,0,chr$("BUTTON"),chr$("&Unused"),
		; WS_CHILD or WS_CLIPSIBLINGS or WS_TABSTOP,
		; xUserB, yUserB, ed_W, butH, hParent,ID_B3,_INSTANCE,0
		; mov h_B3,eax	; show with SetWindowPos
		; invoke SetWindowLong,h_B3,GWL_WNDPROC,SubHook
		; mov lpOldHook, eax
		; invoke ShowWindow,h_B3,SW_SHOWNORMAL
		; mov eax,butY
		; sub ed_H,eax
		; add yUserB,eax
		; .endif
		; info static - tell the user what's going on ;-)
		invoke CreateWindowEx,0,chr$("STATIC"),0,
		WS_CHILD or WS_CLIPSIBLINGS,
		xUserB, yUserB, ed_W, ed_H, hParent,ID_IC,_INSTANCE,0
		mov h_Info,eax	; show with SetWindowPos
		invoke SendMessage, h_Info, WM_SETFONT, ButFnt,1
		invoke ShowWindow,h_Info,SW_SHOWNORMAL

		; invoke MessageBox,0,str$(eax),chr$("Control added"),MB_OK

	.ENDIF
	invoke FindWindowEx, hLVP, NULL, chr$("SysListView32"), NULL
	  .IF eax
	    mov hLV, eax
	    invoke GetDlgCtrlID,eax
	    mov hLVID,eax
	    invoke ShowWindow, hLVP, SW_HIDE

	    mov lvi.imask, 0
	    mov lvi.iItem, 0
	    mov lvi.iSubItem, 0

	    ColW 0, ColW0	;300
	    ColW 1, ColW1	;60
	    ColW 2, ColW2	;0
	    ColW 3, ColW3	;120
	    ColW 4, ColW4	;0

	    invoke FindWindowEx, hLV, NULL, chr$("SysHeader32"), NULL
	    mov hLVH,eax
	    ; show eax ; if needed, show a number
	    invoke SendMessage, hLVH, WM_LBUTTONDOWN, 0, ColM3	;380
	    invoke SendMessage, hLVH, WM_LBUTTONUP, 0, ColM3
	    invoke SendMessage, hLVH, WM_LBUTTONDOWN, 0, ColM3 ;ColW
	    invoke SendMessage, hLVH, WM_LBUTTONUP, 0, ColM3

	    RGB 160,255,255	; turquoise
	    invoke SendDlgItemMessage,hLVP, hLVID, LVM_SETBKCOLOR,0,eax
	    RGB 160,255,255
	    invoke SendDlgItemMessage,hLVP, hLVID, LVM_SETTEXTBKCOLOR,0,eax
	    RGB 204,000,000 ; dark red
	    invoke SendDlgItemMessage,hLVP, hLVID, LVM_SETTEXTCOLOR,0,eax

	    .if HideFolders
	    mov lvFlag,IDYES

	    mov lvi.imask, 0
	    mov lvi.iItem, 0
	    mov lvi.iSubItem, 0

	    invoke SendDlgItemMessage,hLVP, hLVID, LVM_GETITEMCOUNT, 0, 0
	    mov lvCt,eax
	    ; invoke MessageBox,0,cat$(str$(eax),chr$(" items")),
	    ; chr$("ListView:"),MB_OKCANCEL
	    mov lvPos,0
	    .WHILE lvCt>0
	    	mov lvi.imask, LVIF_TEXT
	    	mov eax,lvPos
	    	mov lvi.iItem, eax
	    	mov lvi.iSubItem, 0
	    	mov eax,pBuf
	    	mov lvi.pszText, eax
	    	mov lvi.cchTextMax,lBuf
	    	invoke SendDlgItemMessage,hLVP, hLVID, LVM_GETITEM, 0, addr lvi
	    	.if len(pBuf)<2
	    	     invoke MessageBox,0,pBuf,chr$("Break - Item not found"),MB_OK
	    	    .break
	    	.endif
	    	.if eax==0
	    	   invoke MessageBox,0,pBuf,chr$("Item not found"),MB_OK
	    	.else
	    	   .if len(pBuf)>=2
			; looking for "." is a LOUSY LAZY method
			; for users who don't disable extensions
	    	      .if istring(1, pBuf, chr$("."))==0 ; no ending, suspicious
	    	    	mov eax,IDYES	; fake
			; invoke MessageBox,0,pBuf,
			; chr$("Delete from ListView?"),MB_YESNO
			mov lvFlag,eax
			.if eax==IDYES
			  mov lvi.imask, 0
			  mov lvi.iItem, 0
			  mov lvi.iSubItem, 0
			  invoke SendDlgItemMessage,hLVP, hLVID,
			  LVM_DELETEITEM, lvPos, addr lvi
			.endif
	    	      .else
			inc lvPos
			; invoke MessageBox,0,pBuf,
			; chr$("Has an ending, do NOT delete from ListView"),
			; MB_YESNO
	    	      .endif
	    	   .endif
	    	.endif
	    	dec lvCt
	    .ENDW
	    .endif ; HideF
	    ; simulate two mouseclicks on "Date modified"
	    invoke SendMessage, hLVH, WM_LBUTTONDOWN, 0, 380 ;ColW
	    invoke SendMessage, hLVH, WM_LBUTTONUP, 0, 380
	    invoke SendMessage, hLVH, WM_LBUTTONDOWN, 0, 380
	    invoke SendMessage, hLVH, WM_LBUTTONUP, 0, 380
	    invoke ShowWindow, hLVP, SW_SHOW
	  .ENDIF
	.ELSE
		invoke MessageBox,0,chr$("NO lst2"),str$(hLVP),MB_OKCANCEL		
	.ENDIF
; ***************************** end WM_NOTIFY ************************
	DEFAULT
	.if ShowMSG==IDOK
		invoke MessageBox,0,str$(eax),chr$("Unknown notify:"),MB_OKCANCEL
		mov ShowMSG, eax
	.endif
	ENDSW
  default

  ENDSW

  invoke DefWindowProc, hwnd, uMsg, wParam, lParam
  ret

DlgHook	endp

SubHook	proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL LocBuf[lBuf]:BYTE, pBuf:DWORD
  ClearLocals		; first instruction after LOCALS 
  lea eax, LocBuf	; general purpose buffer
  mov pBuf,eax	; pointer to buffer

  .IF h_Info
	SWITCH uMsg
	case WM_COMMAND
	  info chr$("WM_COMMAND")
	  show wParam

	case WM_NOTIFY
	  info chr$("WM_NOTIFY")
	  show wParam

	case WM_LBUTTONUP
	switch hwnd
	case h_B1
	  .IF HideFolders
	      mov eax, chr$("&Hide folders")
	  .else
	      mov eax, chr$("&Show folders")
	  .endif
	  invoke SendMessage, h_B1, WM_SETTEXT, 0, eax
	  btc HideFolders,0
	  info cfm$("You changed\nthe Folder view")

	  invoke GetDlgItem, hParent, cmb1	; has to be repeated because 
	  mov hCombo, eax		; Explorer creates it anew...

	  invoke GetDlgItem, hParent, edt1	; filename editbox
	  mov hFileEd,eax

	  invoke SendMessage, hCombo, CB_GETCURSEL,0,0
	  switch eax
	  case 0
		  lea edx, FS0
	  case 1
		  lea edx, FS1
	  case 2
		  lea edx, FS2
	  case 3
		  lea edx, FS3
	  case 4
		  lea edx, FS4
	  default
		invoke SendMessage, hFileEd, WM_GETTEXT,lBuf,pBuf
		mov edx,eax
	  endsw
	  invoke SendMessage, hFileEd,WM_SETTEXT,0,edx
	  invoke GetDlgItem, hParent, IDOK
	  mov hOK,eax
	  invoke SetFocus,hOK
	  invoke PostMessage, hOK, WM_KEYDOWN, VK_SPACE, 0
	  invoke PostMessage, hOK, WM_CHAR, VK_SPACE, 0
	  invoke PostMessage, hOK, WM_KEYUP, VK_SPACE, 0 ; see FOLDERCHANGE

	case h_B2
	  info cfm$("You clicked the\nsecond button")
	case h_B3
	  info cfm$("You clicked the\nthird button")
	default
	  info cfm$("You clicked\nanother button")
	  invoke MessageBox, 0,chr$("You clicked another button"),addr AppName,MB_OK

	endsw

	default

	ENDSW
 .ENDIF
  invoke CallWindowProc,lpOldHook,hwnd,uMsg,wParam,lParam
  ret
SubHook	endp

ShowNum	proc Numb:DWORD
	pushad
	  invoke dwtoa,Numb,ADDR dwtoaBuf
	  invoke MessageBox,NULL,addr NumBuf,addr AppName,MB_OKCANCEL
	popad
	ret
ShowNum	endp

end start

OPT_SUSY WINDOWS

28713 - Large icons
28714 - Small icons
28715 - List
28716 - Details
28717 - Thumbnails
28718 - Tiles
The last 2 do not work on Windows 2000, just on XP.

	.if eax==0
	  pushad
	  pushfd
	  invoke GetLastError
	  mov edi,eax
	  invoke FormatMessage,FORMAT_MESSAGE_FROM_SYSTEM,
	  NULL,edi,0,ADDR buffer,MAX_PATH,NULL
	  invoke MessageBox,0,addr buffer,addr AppName,MB_OK
	  popfd
	  popad
	.endif


lResult = SendMessage(
	    // returns int in lResult
   (HWND) hWndControl,
	    // handle to destination control
   (UINT) LVM_SETVIEW,
	    // message ID
   (WPARAM) wParam,
	    // = (WPARAM) (DWORD) iView;
   (LPARAM) lParam
	    // = 0; not used, must be zero

    iView
        DWORD that specifies the view.
    lParam
        Must be zero.

Return Value

Returns 1 if successful, or -1 otherwise.
For example, -1 is returned if the view is invalid.

Remarks

    Following are the values for views.

        * LV_VIEW_DETAILS
        * LV_VIEW_ICON
        * LV_VIEW_LIST
        * LV_VIEW_SMALLICON
        * LV_VIEW_TILE

Note  To use this API, you must provide a manifest specifying Comclt32.dll version 6.0.
http://msdn2.microsoft.com/en-us/library/bb761220.aspx

OPENFILENAMEA	STRUCT
 lStructSize	DWORD ?
 hwndOwner	DWORD ?
 hInstance	DWORD ?
 lpstrFilter	DWORD ?
 lpstrCustomFilter	DWORD ?
 nMaxCustFilter	DWORD ?
 nFilterIndex	DWORD ?
 lpstrFile	DWORD ?
 nMaxFile	DWORD ?
 lpstrFileTitle	DWORD ?
 nMaxFileTitle	DWORD ?
 lpstrInitialDir	DWORD ?
 lpstrTitle	DWORD ?
 Flags	DWORD ?
 nFileOffset	WORD ?
 nFileExtension	WORD ?
 lpstrDefExt	DWORD ?
 lCustData	DWORD ?
 lpfnHook	DWORD ?
 lpTemplateName	DWORD ?
OPENFILENAMEA	ENDS
